<?php
if (constant("FILE_SHELLINABOX_CONF") === null)
{
    require_once(dirname(__FILE__). "/../contain.php");
}
require_once(dirname(__FILE__)."/utils.php");

/**
 * Check if the port is occupied.
 *
 * @param array $request    The request from broswer. Contains the config items.
 * @return array ("err"=>ERR_SUCCEED, "status"=>ENABLE)
 */
function checkport(array $request){
    $respond = array();

    $respond["status"] = DISABLE;
    $port = $request['port'];
    if(\UNAS\Utility\IsPortUsed($port)){
        if(getShellinboxPort() == $port){
            $respond["status"] = ENABLE;
        }
    }else{
        $respond["status"] = ENABLE;
    }
    $respond["err"] = ERR_SUCCEED;
    return $respond;
}

/**
 * Get shellinabox conf.
 *
 * @return array ("err"=>ERR_SUCCEED, "shellinaboxstate"=>ENABLE, "shellinaboxport"=>"4200", "reverseproxy"=>ENABLE)
 */
function getshellinaboxconf(){
    $respond = array(
        "err"=>ERR_SUCCEED,
        "shellinaboxport" => getShellinboxPort(),
        "shellinaboxstate" => getShellinaboxStatus(),
        'reverseproxy'=> getProxyState()
    );

    return $respond;
}

/**
 * Enable shellinabox.
 *
 * @param array $request    The request from broswer. Contains the config items.
 * @return array ("err"=>ERR_SUCCEED)
 */
function enable_shellinabox($request){
    $respond = array();

    $port = $request['port'];
    $proxy = $request['reverseproxy'];
    setShellinaboxConfig($port);
    setWebSSHProxy($proxy,$port);
    if(getShellinaboxStatus() == DISABLE){
        exec(CMD_SHELLINABOX_START);
    }else{
        exec(CMD_SHELLINABOX_RESTART);
    }
    exec(CMD_SHELLINABOX_ENABLE);
    $eventDes = "##$@sshshell@$##Enable SSH Terminal Service##$@sshshell@$####$@sshshell@$##,##$@sshshell@$## ##$@sshshell@$##Port##$@sshshell@$####$@sshshell@$##:##$@sshshell@$## ".$port;
    WriteLog("Information", $eventDes);
    $respond["err"] = ERR_SUCCEED;
    return $respond;
}

/**
 * Disable shellinabox.
 *
 * @param array $request    The request from broswer. Contains the config items.
 * @return array ("err"=>ERR_SUCCEED)
 */
function disable_shellinabox($request){
    $port = $request['port'];
    $proxy = $request['reverseproxy'];
    setShellinaboxConfig($port);
    setWebSSHProxy($proxy,$port);
    exec(CMD_SHELLINABOX_STOP);
    exec(CMD_SHELLINABOX_DISABLE);
    $eventDes = "##$@sshshell@$##Disable SSH Terminal Service##$@sshshell@$##";
    WriteLog("Information", $eventDes);
    $respond["err"] = ERR_SUCCEED;
    return $respond;
}

/**
 * Get the port used by shellinabox.
 * 
 * @return array ("err"=>ERR_SUCCEED, "shellinaboxport"=>"4200")
 */
function getcurrentport(){
    $respond = array(
        "err"=>ERR_SUCCEED,
        "shellinaboxport" => getShellinboxPort()
    );

    return $respond;
}
?>
