<?php
/**
 * U-NAS Web SSh Proxy Class API
 *
 * PHP Version 5 surpport
 * @version 1.0.0
 * @package UNAS OS 3.0 Transmission
 * @copyright (c) 2016 Yu Technologies.Inc
 *
 */
if (constant("FILE_SHELLINABOX_CONF") === null)
{
    require_once(dirname(__FILE__). "/../contain.php");
}
require_once '/unas/api/php/file.php';
require_once '/unas/api/php/utility.php';
use \UNAS\File\File as File;
class WebSSH{
	const UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTP = '/unas/etc/apache2/apps/desktop/http/sshshell.conf';
	const UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTPS = '/unas/etc/apache2/apps/desktop/https/sshshell.conf';
	const UNAS_WEBSSH_REVERSE_PROXY_CONF = '/unas/etc/sshshell/ReverseProxy.conf';
	function __construct(){

	}
	function __destruct(){

	}
	public function ModifyWebSSHProxySettings($port, $reverseproxy){
		if($reverseproxy == ENABLE){
			$this->AddReverseProxy($port);
			$this->EnableReverseProxy();
		}else{
			$this->DeleteReverseProxy();
		}
		$this->ReloadApache2();
	}
	public function GetProxysState(){
		return is_link(self::UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTP) || is_link(self::UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTPS);
	}
	public function GetProxys(){
		return $this->GetReverseProxySettings(self::UNAS_WEBSSH_REVERSE_PROXY_CONF);
	}
	public function DeleteReverseProxy(){
		$cmd = "/usr/bin/sudo rm -rf ".self::UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTP." ".self::UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTPS;
		exec($cmd);
	}
	public function AddReverseProxy($port){
		$proxys = $this->GetReverseProxySettings(self::UNAS_WEBSSH_REVERSE_PROXY_CONF);
		$proxys['webssh']=$port;
		$this->SetReverseProxySettings(self::UNAS_WEBSSH_REVERSE_PROXY_CONF,$proxys);
	}

	public function GetReverseProxySettings($file){
		$proxys = array();
		$f_arr = file($file);
		for($i=0; $i<count($f_arr); $i++){
			if(preg_match("/ProxyPass/", $f_arr[$i]) && preg_match("/webssh/", $f_arr[$i])){
				$args = explode(" ",$f_arr[$i]);
				$proxys[trim(explode('/',trim($args[1]))[1])] = trim(explode('/',trim(explode('localhost:',$args[2])[1]))[0]);
			}
		}
		return $proxys;
	}

	public function SetReverseProxySettings($file,$proxys){
		$str = 'ProxyRequests Off' . PHP_EOL;
		$str .= 'UseCanonicalName Off' . PHP_EOL;
		$str .= 'SSLProxyEngine On' . PHP_EOL;
		$str .= 'RedirectMatch /webssh$ /webssh/' . PHP_EOL;
		foreach($proxys as $path=>$port){
			$str .= 'ProxyPass /'.$path.'/ https://localhost:' .$port. '/' . PHP_EOL;
			$str .= 'ProxyPassReverse /'.$path.'/ https://localhost:' .$port. '/' . PHP_EOL;
		}
		return $this->WriteStringToFile($str,$file);
	}
	private function WriteStringToFile($str,$file,$append=false){
		if(!file_exists($file)){
			$result = exec("/usr/bin/sudo touch ".$file,$out,$res);
		}
		if(!is_writable($file)){
			$f = new \UNAS\File\File($file);
			$f->chmod('666');
			if($append){
				file_put_contents($file, $str, FILE_APPEND);
			}else{
				file_put_contents($file, $str);
			}
			$f->chmod('644');
		}else{
			file_put_contents($file, $str);
		}
		return true;
	}
	public function EnableReverseProxy(){
		$cmd = "/usr/bin/sudo ln -s ".self::UNAS_WEBSSH_REVERSE_PROXY_CONF." ".self::UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTP;
		$cmd .= ";/usr/bin/sudo ln -s ".self::UNAS_WEBSSH_REVERSE_PROXY_CONF." ".self::UNAS_WEBSSH_REVERSE_PROXY_LINK_HTTPS;
		exec($cmd);
	}
	public function ReloadApache2(){
		exec("/usr/bin/sudo /etc/init.d/apache2 reload");
	}
}
?>
