<?php
if (constant("FILE_SHELLINABOX_CONF") === null)
{
    require_once(dirname(__FILE__). "/../contain.php");
}

/**
 * Some settings may crush /etc/default/shellinabox-unas.
 * Then it's the time for this function.
 */
function recoverShellinaboxConf(){
    $cmd = "/usr/bin/sudo cp /unas/etc/sshshell/shellinabox-unas.backup /etc/default/shellinabox-unas";
    exec($cmd);
}

function getShellinboxPort(){
    $cur_port = "";
    $f_arr = array();
    $f_arr = file(FILE_SHELLINABOX_CONF);
    foreach ($f_arr as $line){
        if(preg_match("/^SHELLINABOX_PORT=+(.*)/",$line,$match)){
            $cur_port = trim($match[1]);
            break;
        }
    }
    if ($cur_port == ""){
        recoverShellinaboxConf();
        $f_arr = file(FILE_SHELLINABOX_CONF);
        foreach ($f_arr as $line){
            if(preg_match("/^SHELLINABOX_PORT=+(.*)/",$line,$match)){
                $cur_port = trim($match[1]);
                break;
            }
        }
        exec(CMD_SHELLINABOX_RESTART);
    }
    return $cur_port;
}

function getShellinaboxStatus(){
    exec(CMD_SHELLINABOX_STATUS, $content, $ret);
    if ($ret == 0){
        return ENABLE;
    }else{
        return DISABLE;
    }
}

function getProxyState(){
    require_once(dirname(__FILE__)."/sshshell.class.php");
    $reverseproxy = DISABLE;
    $webssh = new WebSSH();
    $reverseproxy = $webssh->GetProxysState() ? ENABLE : DISABLE;
    return $reverseproxy;
}

function setShellinaboxConfig($cur_port){
    $f_arr = array();
    $f_arr = file(FILE_SHELLINABOX_CONF);
    for($i=0;$i<count($f_arr);$i++){
        $val = $f_arr[$i];
        if(preg_match("/^SHELLINABOX_PORT=+(.*)/",$val,$match)){
            // if($cur_port != null){
            $f_arr[$i] = "SHELLINABOX_PORT=".$cur_port."\n";
            // }
            continue;
        }
    }
    exec("/usr/bin/sudo chmod 777 ".FILE_SHELLINABOX_CONF);
    file_put_contents(FILE_SHELLINABOX_CONF, implode(PHP_EOL, $f_arr));
    exec("/usr/bin/sudo chmod 644 ".FILE_SHELLINABOX_CONF);
}

function setWebSSHProxy($state,$port){
    $webssh = new WebSSH();
    $webssh->ModifyWebSSHProxySettings($port,$state);
}

?>
